<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.caroutrecord_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/caroutrecord";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "索引ID",
              prop: "indexId",
              rules: [{
                required: true,
                message: "请输入索引ID",
                trigger: "blur"
              }]
            },
            {
              label: "车场唯一编号",
              prop: "parkKey",
              rules: [{
                required: true,
                message: "请输入车场唯一编号",
                trigger: "blur"
              }]
            },
            {
              label: "车牌号码",
              prop: "carNo",
              rules: [{
                required: true,
                message: "请输入车牌号码",
                trigger: "blur"
              }]
            },
            {
              label: "订单号",
              prop: "orderNo",
              rules: [{
                required: true,
                message: "请输入订单号",
                trigger: "blur"
              }]
            },
            {
              label: "车辆类型",
              prop: "carTypeNo",
              rules: [{
                required: true,
                message: "请输入车辆类型",
                trigger: "blur"
              }]
            },
            {
              label: "入场时间（V1.1版本返回字段）",
              prop: "enterTime",
              rules: [{
                required: true,
                message: "请输入入场时间（V1.1版本返回字段）",
                trigger: "blur"
              }]
            },
            {
              label: "入口车道名称（V1.1版本返回字段）",
              prop: "enterGateName",
              rules: [{
                required: true,
                message: "请输入入口车道名称（V1.1版本返回字段）",
                trigger: "blur"
              }]
            },
            {
              label: "出场时间	",
              prop: "outTime",
              rules: [{
                required: true,
                message: "请输入出场时间	",
                trigger: "blur"
              }]
            },
            {
              label: "出口车道名称	",
              prop: "outGateName",
              rules: [{
                required: true,
                message: "请输入出口车道名称	",
                trigger: "blur"
              }]
            },
            {
              label: "出口操作员	",
              prop: "outOperatorName",
              rules: [{
                required: true,
                message: "请输入出口操作员	",
                trigger: "blur"
              }]
            },
            {
              label: "车辆状态（0-未锁 1-锁定）",
              prop: "lockCar",
              rules: [{
                required: true,
                message: "请输入车辆状态（0-未锁 1-锁定）",
                trigger: "blur"
              }]
            },
            {
              label: "出场图片	",
              prop: "outImgPath",
              rules: [{
                required: true,
                message: "请输入出场图片	",
                trigger: "blur"
              }]
            },
            {
              label: "订单总金额（单位元）",
              prop: "totalAmount",
              rules: [{
                required: true,
                message: "请输入订单总金额（单位元）",
                trigger: "blur"
              }]
            },
            {
              label: "免费放行原因",
              prop: "freeReason",
              rules: [{
                required: true,
                message: "请输入免费放行原因",
                trigger: "blur"
              }]
            },
            {
              label: "社区id",
              prop: "agencyId",
              rules: [{
                required: true,
                message: "请输入社区id",
                trigger: "blur"
              }]
            },
            {
              label: "小区id",
              prop: "residentialId",
              rules: [{
                required: true,
                message: "请输入小区id",
                trigger: "blur"
              }]
            },
            {
              label: "企业id",
              prop: "enterpriseId",
              rules: [{
                required: true,
                message: "请输入企业id",
                trigger: "blur"
              }]
            },
            {
              label: "路径",
              prop: "orgPosition",
              rules: [{
                required: true,
                message: "请输入路径",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.caroutrecord_add, false),
          viewBtn: this.vaildData(this.permission.caroutrecord_view, false),
          delBtn: this.vaildData(this.permission.caroutrecord_delete, false),
          editBtn: this.vaildData(this.permission.caroutrecord_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
